= How do I start a project with Maven? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

This guide is intended as a reference for those working with Maven for the first time.
Maven is already installed on the system at `<%= node['maven']['m2_home'] %>`.
Maven will work for small projects, but Maven is best in helping teams operate more effectively by allowing team members 
to focus on what the stakeholders of a project require. Maven is great at building the desired infrastructure.

== What is Maven ==
At first glance Maven can appear to be many things, but in a nutshell Maven is an attempt to apply patterns to a project's build infrastructure in order to promote comprehension and productivity by providing a clear path in the use of best practices. Maven is essentially a project management and comprehension tool and as such provides a way to help with managing:

 * Builds
 * Documentation
 * Reporting
 * Dependencies
 * SCMs
 * Releases
 * Distribution
 
== How do I make my first Maven project ==
To create our first Maven project we are going to use Maven's archetype mechanism.
An archetype is defined as an original pattern or model from which all other things of the same kind are made.
In Maven, an archetype is a template of a project which is combined with some user input to produce a working 
Maven project that has been tailored to the user's requirements. 
We are going to show you how the archetype mechanism works now, 
but if you would like to know more about archetypes please refer to Apache's 
[http://maven.apache.org/guides/introduction/introduction-to-archetypes.html Introduction to Archetypes].

In order to create the simplest of Maven projects, execute the following from the command line

`mvn -B archetype:generate -DarchetypeGroupId=org.apache.maven.archetypes -DgroupId=com.mycompany.app -DartifactId=my-app`

This will create the `my-app` directory and in it a `pom.xml` file is created. 
`pom.xml` contains the Project Object Model (POM) for this project. The POM is the basic unit of work in Maven. 
This is important to remember because Maven is inherently project-centric in that everything revolves around the notion of a project. 
In short, the POM contains every important piece of information about your project for finding anything related to your project.
Understanding the POM is important and new users are encouraged to refer to the 
[http://maven.apache.org/guides/introduction/introduction-to-the-pom.html Introduction to the POM].

This is a very simple POM but still displays the key elements every POM contains

 * '''project''' This is the top-level element in all Maven pom.xml files.
 * '''modelVersion''' This element indicates what version of the object model this POM is using. The version of the model itself changes very infrequently but it is mandatory in order to ensure stability of use if and when the Maven developers deem it necessary to change the model.
 * '''groupId''' This element indicates the unique identifier of the organization or group that created the project. The groupId is one of the key identifiers of a project and is typically based on the fully qualified domain name of your organization. For example org.apache.maven.plugins is the designated groupId for all Maven plug-ins.
 * '''artifactId''' This element indicates the unique base name of the primary artifact being generated by this project. The primary artifact for a project is typically a JAR file. Secondary artifacts like source bundles also use the artifactId as part of their final name. A typical artifact produced by Maven would have the form <artifactId>-<version>.<extension> (for example, myapp-1.0.jar).
 * '''packaging''' This element indicates the package type to be used by this artifact (e.g. JAR, WAR, EAR, etc.). This not only means if the artifact produced is JAR, WAR, or EAR but can also indicate a specific lifecycle to use as part of the build process. (The lifecycle is a topic we will deal with further on in the guide. For now, just keep in mind that the indicated packaging of a project can play a part in customizing the build lifecycle.) The default value for the packaging element is JAR so you do not have to specify this for most projects.
 * '''version''' This element indicates the version of the artifact generated by the project. Maven goes a long way to help you with version management and you will often see the SNAPSHOT designator in a version, which indicates that a project is in a state of development. We will discuss the use of snapshots and how they work further on in this guide.
 * '''name''' This element indicates the display name used for the project. This is often used in Maven's generated documentation.
 * '''url''' This element indicates where the project's site can be found. This is often used in Maven's generated documentation.
 * '''description''' This element provides a basic description of your project. This is often used in Maven's generated documentation.

== How do I compile my application sources ==

Change to the directory where pom.xml is created by archetype:generate and execute the following command to compile your 
application sources

{{{
mvn compile
}}}

The first time you execute this (or any other) command, Maven will need to download all the plugins and related dependencies 
it needs to fulfill the command. From a clean installation of Maven, this can take quite a while. 
If you execute the command again, Maven will now have what it needs, so it won't need to download anything new and will be 
able to execute the command much more quickly.

As you can see from the output, the compiled classes were placed in ${basedir}/target/classes, which is another standard 
convention employed by Maven. So, if you're a keen observer, you'll notice that by using the standard conventions, the POM 
above is very small and you haven't had to tell Maven explicitly where any of your sources are or where the output should go. 
By following the standard Maven conventions, you can get a lot done with very little effort! Just as a casual comparison, 
let's take a look at what you might have had to do in [./StartWithAnt Ant to accomplish the same thing].

Now, this is simply to compile a single tree of application sources and the Ant script shown is pretty much the same size as 
the POM shown above.

== How do I compile my test sources and run my unit tests ==

Now you're successfully compiling your application's sources and now you've got some unit tests that you want to compile and 
execute.

{{{
mvn test
}}}

Some things to notice about the output:
 * Maven downloads more dependencies this time. These are the dependencies and plugins necessary for executing the tests (it already has the dependencies it needs for compiling and won't download them again).
 * Before compiling and executing the tests Maven compiles the main code (all these classes are up to date because we haven't changed anything since we compiled last).

If you simply want to compile your test sources (but not execute the tests), you can execute the following:

{{{
mvn test-compile
}}}

<%= node['trac']['wiki']['footer'] %>